#include <bits/stdc++.h>

using namespace std;
const int NAJ = 1e6 +9;
int N,Q;
int niz[NAJ];
int resenja[NAJ];
int racunaj(int L, int R){
    int x;
    x = niz[L] & niz[L+1];
    for(int i = L+2; i <= R; i++){
        x = x & niz[i];
    }
    return x;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0),cout.tie(0);
    cin >> N >> Q;
    for(int i = 1; i <= N; i++){
        cin >> niz[i];
    }
    int L,R;
    for(int i = 0; i < Q; i++){
        cin >> L >> R;
        resenja[i] =  racunaj(L,R);
    }
    for(int i = 0; i < Q; i++){
        cout << resenja[i] << endl;
    }
    return 0;
}